module rc5decoderII(clk,in,rdy,rc5code);
input clk,in;
output rdy;
output [13:0] rc5code;

wire short_pulse,long_pulse,short_gap,long_gap;
reg[3:0] state;
wire time_out;
reg [13:0] rc5temp;
reg rc5ready;
reg [13:0] rc5code;

 

 timer t1(.clk(clk),.in(~in),
        .lp(long_pulse),.sp(short_pulse),
	   .lg(long_gap),.sg(short_gap),.to(time_out));
 
 

  always@(posedge clk)
  begin 
	if(time_out)
	begin
	   state=4'd0; rc5ready=0;
	end
	else
	begin
       
     case(state)
     4'd0: 
	   begin
	    rc5temp=0; 
	    if(~in) state=4'd1;
	    else state=4'd0;   
	   end

	   
	4'd1: 
	   begin
		 rc5temp={rc5temp[12:0],1'b1};
		 state=4'd2;
	   end
	   
	 4'd2:
	   begin
	   //stan S0
	    if(short_pulse&&long_pulse) state=4'd0;
	    else
	    if(short_pulse&&!long_pulse) state=4'd3; //S1
	    else
	    if(long_pulse&&!short_pulse) state=4'd4;
	    else state=4'd2;
	   end
  
	 4'd3:
	   begin
		//stan S1
		if(short_gap&&long_gap) state=4'd0;
		else
		if(short_gap&&!long_gap) state=4'd5; //do S0
		else state=4'd3;
	   end
	   
	   
	 4'd4:
	   begin
	    // odebrano bit o wartoci 0
	    rc5temp={rc5temp[12:0],1'b0};
	    state=4'd6; //do stanu S2
	   end
	   
	 4'd5:
	   begin
		// odebrano bit o wartoci 1
		rc5temp={rc5temp[12:0],1'b1};    
	     state=4'd2; //do stanu S0
	   end
   
	 4'd6:
	   begin
		//stan S2
		if(short_gap&&long_gap) state=4'd0;
		else
		if(long_gap&&!short_gap) state=4'd5; 
		else
		if(short_gap&&!long_gap) state=4'd7;
		else state=4'd6;
	   end
	    
	 4'd7:
	   begin
	    //stan S3
	    if(short_pulse&&long_pulse) state=4'd0;
	    else
	    if(short_pulse&&!long_pulse) state=4'd4; 
	    else state=4'd7;
	   end
	 endcase
	 
       if(rc5temp[13]==1'b1)
	  begin
 
	    rc5code=rc5temp;
	    rc5ready=1; state=4'd0;
	  end
	  
	  
	end

  end

   assign rdy=rc5ready;
 


endmodule
